diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/wifi/model/wifi-phy.cc ns-3.34/src/wifi/model/wifi-phy.cc
--- ns-3.33/src/wifi/model/wifi-phy.cc	2021-01-09 10:19:23.000000000 -0800
+++ ns-3.34/src/wifi/model/wifi-phy.cc	2021-07-14 10:31:07.000000000 -0700
@@ -1899,683 +1570,73 @@
     }
 }
 
-WifiMode
-WifiPhy::GetHtPhyHeaderMode ()
+Time
+WifiPhy::GetPreambleDetectionDuration (void)
 {
-  return WifiPhy::GetHtMcs0 ();
+  return MicroSeconds (4);
 }
 
-WifiMode
-WifiPhy::GetVhtPhyHeaderMode ()
+Time
+WifiPhy::GetStartOfPacketDuration (const WifiTxVector& txVector)
 {
-  return WifiPhy::GetVhtMcs0 ();
+  return MicroSeconds (4);
 }
 
-WifiMode
-WifiPhy::GetHePhyHeaderMode ()
+Time
+WifiPhy::GetPayloadDuration (uint32_t size, const WifiTxVector& txVector, WifiPhyBand band, MpduType mpdutype, uint16_t staId)
 {
-  return WifiPhy::GetHeMcs0 ();
+  uint32_t totalAmpduSize;
+  double totalAmpduNumSymbols;
+  return GetPayloadDuration (size, txVector, band, mpdutype, false, totalAmpduSize, totalAmpduNumSymbols, staId);
 }
 
 Time
-WifiPhy::GetPreambleDetectionDuration (void)
+WifiPhy::GetPayloadDuration (uint32_t size, const WifiTxVector& txVector, WifiPhyBand band, MpduType mpdutype,
+                             bool incFlag, uint32_t &totalAmpduSize, double &totalAmpduNumSymbols,
+                             uint16_t staId)
 {
-  return MicroSeconds (4);
+  return GetStaticPhyEntity (txVector.GetModulationClass ())->GetPayloadDuration (size, txVector, band, mpdutype,
+                                                                                  incFlag, totalAmpduSize, totalAmpduNumSymbols,
+                                                                                  staId);
 }
 
 Time
-WifiPhy::GetPhyTrainingSymbolDuration (WifiTxVector txVector)
+WifiPhy::CalculatePhyPreambleAndHeaderDuration (const WifiTxVector& txVector)
 {
-  uint8_t Ndltf, Neltf;
-  //We suppose here that STBC = 0.
-  //If STBC > 0, we need a different mapping between Nss and Nltf (IEEE 802.11n-2012 standard, page 1682).
-  uint8_t nss = txVector.GetNssMax (); //so as to cover also HE MU case (see section 27.3.10.10 of IEEE P802.11ax/D4.0)
-  if (nss < 3)
-    {
-      Ndltf = nss;
-    }
-  else if (nss < 5)
-    {
-      Ndltf = 4;
-    }
-  else if (nss < 7)
-    {
-      Ndltf = 6;
-    }
-  else
-    {
-      Ndltf = 8;
-    }
-
-  if (txVector.GetNess () < 3)
-    {
-      Neltf = txVector.GetNess ();
-    }
-  else
-    {
-      Neltf = 4;
-    }
-
-  switch (txVector.GetPreambleType ())
-    {
-    case WIFI_PREAMBLE_HT_MF:
-      return MicroSeconds (4 + (4 * Ndltf) + (4 * Neltf));
-    case WIFI_PREAMBLE_HT_GF:
-      return MicroSeconds ((4 * Ndltf) + (4 * Neltf));
-    case WIFI_PREAMBLE_VHT_SU:
-    case WIFI_PREAMBLE_VHT_MU:
-      return MicroSeconds (4 + (4 * Ndltf));
-    case WIFI_PREAMBLE_HE_SU:
-    case WIFI_PREAMBLE_HE_MU:
-    case WIFI_PREAMBLE_HE_TB:
-      return MicroSeconds (4 + (8 * Ndltf));
-    default:
-      return MicroSeconds (0);
-    }
+  return GetStaticPhyEntity (txVector.GetModulationClass ())->CalculatePhyPreambleAndHeaderDuration (txVector);
 }
 
 Time
-WifiPhy::GetPhyHtSigHeaderDuration (WifiPreamble preamble)
+WifiPhy::CalculateTxDuration (uint32_t size, const WifiTxVector& txVector, WifiPhyBand band, uint16_t staId)
 {
-  switch (preamble)
-    {
-    case WIFI_PREAMBLE_HT_MF:
-    case WIFI_PREAMBLE_HT_GF:
-      //HT-SIG
-      return MicroSeconds (8);
-    default:
-      //no HT-SIG for non HT
-      return MicroSeconds (0);
-    }
+  Time duration = CalculatePhyPreambleAndHeaderDuration (txVector)
+    + GetPayloadDuration (size, txVector, band, NORMAL_MPDU, staId);
+  NS_ASSERT (duration.IsStrictlyPositive ());
+  return duration;
 }
 
 Time
-WifiPhy::GetPhySigA1Duration (WifiPreamble preamble)
+WifiPhy::CalculateTxDuration (Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector, WifiPhyBand band)
 {
-  switch (preamble)
-    {
-    case WIFI_PREAMBLE_VHT_SU:
-    case WIFI_PREAMBLE_HE_SU:
-    case WIFI_PREAMBLE_VHT_MU:
-    case WIFI_PREAMBLE_HE_MU:
-    case WIFI_PREAMBLE_HE_TB:
-      //VHT-SIG-A1 and HE-SIG-A1
-      return MicroSeconds (4);
-    default:
-      // no SIG-A1
-      return MicroSeconds (0);
-    }
+  return CalculateTxDuration (GetWifiConstPsduMap (psdu, txVector), txVector, band);
 }
 
 Time
-WifiPhy::GetPhySigA2Duration (WifiPreamble preamble)
+WifiPhy::CalculateTxDuration (WifiConstPsduMap psduMap, const WifiTxVector& txVector, WifiPhyBand band)
 {
-  switch (preamble)
-    {
-    case WIFI_PREAMBLE_VHT_SU:
-    case WIFI_PREAMBLE_HE_SU:
-    case WIFI_PREAMBLE_VHT_MU:
-    case WIFI_PREAMBLE_HE_MU:
-      //VHT-SIG-A2 and HE-SIG-A2
-      return MicroSeconds (4);
-    default:
-      // no SIG-A2
-      return MicroSeconds (0);
-    }
+  return GetStaticPhyEntity (txVector.GetModulationClass ())->CalculateTxDuration (psduMap, txVector, band);
 }
 
-Time
-WifiPhy::GetPhySigBDuration (WifiPreamble preamble)
+uint32_t
+WifiPhy::GetMaxPsduSize (WifiModulationClass modulation)
 {
-  switch (preamble)
-    {
-    case WIFI_PREAMBLE_VHT_MU:
-    case WIFI_PREAMBLE_HE_MU:
-      return MicroSeconds (4);
-    default:
-      // no SIG-B
-      return MicroSeconds (0);
-    }
+  return GetStaticPhyEntity (modulation)->GetMaxPsduSize ();
 }
 
-WifiMode
-WifiPhy::GetPhyHeaderMode (WifiTxVector txVector)
+void
+WifiPhy::NotifyTxBegin (WifiConstPsduMap psdus, double txPowerW)
 {
-  WifiPreamble preamble = txVector.GetPreambleType ();
-  switch (preamble)
-    {
-    case WIFI_PREAMBLE_LONG:
-    case WIFI_PREAMBLE_SHORT:
-      {
-        switch (txVector.GetMode ().GetModulationClass ())
-          {
-            case WIFI_MOD_CLASS_OFDM:
-              {
-                switch (txVector.GetChannelWidth ())
-                  {
-                    case 5:
-                      return WifiPhy::GetOfdmRate1_5MbpsBW5MHz ();
-                    case 10:
-                      return WifiPhy::GetOfdmRate3MbpsBW10MHz ();
-                    case 20:
-                    default:
-                      //(Section 17.3.2 "PPDU frame format"; IEEE Std 802.11-2016)
-                      //actually this is only the first part of the PhyHeader,
-                      //because the last 16 bits of the PhyHeader are using the
-                      //same mode of the payload
-                      return WifiPhy::GetOfdmRate6Mbps ();
-                  }
-              }
-            case WIFI_MOD_CLASS_ERP_OFDM:
-              return WifiPhy::GetErpOfdmRate6Mbps ();
-            case WIFI_MOD_CLASS_DSSS:
-            case WIFI_MOD_CLASS_HR_DSSS:
-              {
-                if (preamble == WIFI_PREAMBLE_LONG || txVector.GetMode () == WifiPhy::GetDsssRate1Mbps ())
-                  {
-                    //(Section 16.2.3 "PPDU field definitions" and Section 16.2.2.2 "Long PPDU format"; IEEE Std 802.11-2016)
-                    return WifiPhy::GetDsssRate1Mbps ();
-                  }
-                else
-                  {
-                    //(Section 16.2.2.3 "Short PPDU format"; IEEE Std 802.11-2016)
-                    return WifiPhy::GetDsssRate2Mbps ();
-                  }
-              }
-            default:
-              NS_FATAL_ERROR ("unsupported modulation class");
-              return WifiMode ();
-          }
-      }
-    case WIFI_PREAMBLE_HT_MF:
-    case WIFI_PREAMBLE_HT_GF:
-    case WIFI_PREAMBLE_VHT_SU:
-    case WIFI_PREAMBLE_VHT_MU:
-    case WIFI_PREAMBLE_HE_SU:
-    case WIFI_PREAMBLE_HE_ER_SU:
-    case WIFI_PREAMBLE_HE_MU:
-    case WIFI_PREAMBLE_HE_TB:
-      return WifiPhy::GetOfdmRate6Mbps ();
-    default:
-      NS_FATAL_ERROR ("unsupported preamble type");
-      return WifiMode ();
-    }
-}
-
-Time
-WifiPhy::GetPhyHeaderDuration (WifiTxVector txVector)
-{
-  WifiPreamble preamble = txVector.GetPreambleType ();
-  switch (txVector.GetPreambleType ())
-    {
-    case WIFI_PREAMBLE_LONG:
-    case WIFI_PREAMBLE_SHORT:
-      {
-        switch (txVector.GetMode ().GetModulationClass ())
-          {
-          case WIFI_MOD_CLASS_OFDM:
-            {
-              switch (txVector.GetChannelWidth ())
-                {
-                case 20:
-                default:
-                  //(Section 17.3.3 "PHY preamble (SYNC))" and Figure 17-4 "OFDM training structure"; IEEE Std 802.11-2016)
-                  //also (Section 17.3.2.4 "Timing related parameters" Table 17-5 "Timing-related parameters"; IEEE Std 802.11-2016)
-                  //We return the duration of the SIGNAL field only, since the
-                  //SERVICE field (which strictly speaking belongs to the PHY
-                  //header, see Section 17.3.2 and Figure 17-1) is sent using the
-                  //payload mode.
-                  return MicroSeconds (4);
-                case 10:
-                  //(Section 17.3.2.4 "Timing related parameters" Table 17-5 "Timing-related parameters"; IEEE Std 802.11-2016)
-                  return MicroSeconds (8);
-                case 5:
-                  //(Section 17.3.2.4 "Timing related parameters" Table 17-5 "Timing-related parameters"; IEEE Std 802.11-2016)
-                  return MicroSeconds (16);
-                }
-            }
-          case WIFI_MOD_CLASS_ERP_OFDM:
-            return MicroSeconds (4);
-          case WIFI_MOD_CLASS_DSSS:
-          case WIFI_MOD_CLASS_HR_DSSS:
-            {
-              if ((preamble == WIFI_PREAMBLE_SHORT) && (txVector.GetMode ().GetDataRate (22) > 1000000))
-                {
-                  //(Section 16.2.2.3 "Short PPDU format" and Figure 16-2 "Short PPDU format"; IEEE Std 802.11-2016)
-                  return MicroSeconds (24);
-                }
-              else
-                {
-                  //(Section 16.2.2.2 "Long PPDU format" and Figure 16-1 "Short PPDU format"; IEEE Std 802.11-2016)
-                  return MicroSeconds (48);
-                }
-            }
-          default:
-            NS_FATAL_ERROR ("modulation class is not matching the preamble type");
-            return MicroSeconds (0);
-          }
-      }
-    case WIFI_PREAMBLE_HT_MF:
-    case WIFI_PREAMBLE_VHT_SU:
-    case WIFI_PREAMBLE_VHT_MU:
-      //L-SIG
-      return MicroSeconds (4);
-    case WIFI_PREAMBLE_HE_SU:
-    case WIFI_PREAMBLE_HE_ER_SU:
-    case WIFI_PREAMBLE_HE_MU:
-    case WIFI_PREAMBLE_HE_TB:
-      //LSIG + R-LSIG
-      return MicroSeconds (8);
-    case WIFI_PREAMBLE_HT_GF:
-      return MicroSeconds (0);
-    default:
-      NS_FATAL_ERROR ("unsupported preamble type");
-      return MicroSeconds (0);
-    }
-}
-
-Time
-WifiPhy::GetStartOfPacketDuration (WifiTxVector txVector)
-{
-  return MicroSeconds (4);
-}
-
-Time
-WifiPhy::GetPhyPreambleDuration (WifiTxVector txVector)
-{
-  WifiPreamble preamble = txVector.GetPreambleType ();
-  switch (txVector.GetPreambleType ())
-    {
-    case WIFI_PREAMBLE_LONG:
-    case WIFI_PREAMBLE_SHORT:
-      {
-        switch (txVector.GetMode ().GetModulationClass ())
-          {
-            case WIFI_MOD_CLASS_OFDM:
-              {
-                switch (txVector.GetChannelWidth ())
-                  {
-                    case 20:
-                    default:
-                      //(Section 17.3.3 "PHY preamble (SYNC))" Figure 17-4 "OFDM training structure"
-                      //also Section 17.3.2.3 "Modulation-dependent parameters" Table 17-4 "Modulation-dependent parameters"; IEEE Std 802.11-2016)
-                      return MicroSeconds (16);
-                    case 10:
-                      //(Section 17.3.3 "PHY preamble (SYNC))" Figure 17-4 "OFDM training structure"
-                      //also Section 17.3.2.3 "Modulation-dependent parameters" Table 17-4 "Modulation-dependent parameters"; IEEE Std 802.11-2016)
-                      return MicroSeconds (32);
-                    case 5:
-                      //(Section 17.3.3 "PHY preamble (SYNC))" Figure 17-4 "OFDM training structure"
-                      //also Section 17.3.2.3 "Modulation-dependent parameters" Table 17-4 "Modulation-dependent parameters"; IEEE Std 802.11-2016)
-                      return MicroSeconds (64);
-                  }
-              }
-            case WIFI_MOD_CLASS_ERP_OFDM:
-              return MicroSeconds (16);
-            case WIFI_MOD_CLASS_DSSS:
-            case WIFI_MOD_CLASS_HR_DSSS:
-              {
-                if ((preamble == WIFI_PREAMBLE_SHORT) && (txVector.GetMode ().GetDataRate (22) > 1000000))
-                  {
-                    //(Section 17.2.2.3 "Short PPDU format)" Figure 17-2 "Short PPDU format"; IEEE Std 802.11-2012)
-                    return MicroSeconds (72);
-                  }
-                else
-                  {
-                    //(Section 17.2.2.2 "Long PPDU format)" Figure 17-1 "Long PPDU format"; IEEE Std 802.11-2012)
-                    return MicroSeconds (144);
-                  }
-              }
-            default:
-              NS_FATAL_ERROR ("modulation class is not matching the preamble type");
-              return MicroSeconds (0);
-          }
-      }
-    case WIFI_PREAMBLE_HT_MF:
-    case WIFI_PREAMBLE_VHT_SU:
-    case WIFI_PREAMBLE_VHT_MU:
-    case WIFI_PREAMBLE_HE_SU:
-    case WIFI_PREAMBLE_HE_ER_SU:
-    case WIFI_PREAMBLE_HE_MU:
-    case WIFI_PREAMBLE_HE_TB:
-      //L-STF + L-LTF
-      return MicroSeconds (16);
-    case WIFI_PREAMBLE_HT_GF:
-      //HT-GF-STF + HT-LTF1
-      return MicroSeconds (16);
-    default:
-      NS_FATAL_ERROR ("unsupported preamble type");
-      return MicroSeconds (0);
-    }
-}
-
-Time
-WifiPhy::GetPayloadDuration (uint32_t size, WifiTxVector txVector, WifiPhyBand band, MpduType mpdutype, uint16_t staId)
-{
-  uint32_t totalAmpduSize;
-  double totalAmpduNumSymbols;
-  return GetPayloadDuration (size, txVector, band, mpdutype, false, totalAmpduSize, totalAmpduNumSymbols, staId);
-}
-
-Time
-WifiPhy::GetPayloadDuration (uint32_t size, WifiTxVector txVector, WifiPhyBand band, MpduType mpdutype,
-                             bool incFlag, uint32_t &totalAmpduSize, double &totalAmpduNumSymbols,
-                             uint16_t staId)
-{
-  WifiMode payloadMode = txVector.GetMode (staId);
-  NS_LOG_FUNCTION (size << payloadMode);
-
-  double stbc = 1;
-  if (txVector.IsStbc ()
-      && (payloadMode.GetModulationClass () == WIFI_MOD_CLASS_HT
-          || payloadMode.GetModulationClass () == WIFI_MOD_CLASS_VHT))
-    {
-      stbc = 2;
-    }
-
-  double Nes = 1;
-  //todo: improve logic to reduce the number of if cases
-  //todo: extend to NSS > 4 for VHT rates
-  if (payloadMode == GetHtMcs21 ()
-      || payloadMode == GetHtMcs22 ()
-      || payloadMode == GetHtMcs23 ()
-      || payloadMode == GetHtMcs28 ()
-      || payloadMode == GetHtMcs29 ()
-      || payloadMode == GetHtMcs30 ()
-      || payloadMode == GetHtMcs31 ())
-    {
-      Nes = 2;
-    }
-  if (payloadMode.GetModulationClass () == WIFI_MOD_CLASS_VHT)
-    {
-      if (txVector.GetChannelWidth () == 40
-          && txVector.GetNss (staId) == 3
-          && payloadMode.GetMcsValue () >= 8)
-        {
-          Nes = 2;
-        }
-      if (txVector.GetChannelWidth () == 80
-          && txVector.GetNss (staId) == 2
-          && payloadMode.GetMcsValue () >= 7)
-        {
-          Nes = 2;
-        }
-      if (txVector.GetChannelWidth () == 80
-          && txVector.GetNss (staId) == 3
-          && payloadMode.GetMcsValue () >= 7)
-        {
-          Nes = 2;
-        }
-      if (txVector.GetChannelWidth () == 80
-          && txVector.GetNss (staId) == 3
-          && payloadMode.GetMcsValue () == 9)
-        {
-          Nes = 3;
-        }
-      if (txVector.GetChannelWidth () == 80
-          && txVector.GetNss (staId) == 4
-          && payloadMode.GetMcsValue () >= 4)
-        {
-          Nes = 2;
-        }
-      if (txVector.GetChannelWidth () == 80
-          && txVector.GetNss (staId) == 4
-          && payloadMode.GetMcsValue () >= 7)
-        {
-          Nes = 3;
-        }
-      if (txVector.GetChannelWidth () == 160
-          && payloadMode.GetMcsValue () >= 7)
-        {
-          Nes = 2;
-        }
-      if (txVector.GetChannelWidth () == 160
-          && txVector.GetNss (staId) == 2
-          && payloadMode.GetMcsValue () >= 4)
-        {
-          Nes = 2;
-        }
-      if (txVector.GetChannelWidth () == 160
-          && txVector.GetNss (staId) == 2
-          && payloadMode.GetMcsValue () >= 7)
-        {
-          Nes = 3;
-        }
-      if (txVector.GetChannelWidth () == 160
-          && txVector.GetNss (staId) == 3
-          && payloadMode.GetMcsValue () >= 3)
-        {
-          Nes = 2;
-        }
-      if (txVector.GetChannelWidth () == 160
-          && txVector.GetNss (staId) == 3
-          && payloadMode.GetMcsValue () >= 5)
-        {
-          Nes = 3;
-        }
-      if (txVector.GetChannelWidth () == 160
-          && txVector.GetNss (staId) == 3
-          && payloadMode.GetMcsValue () >= 7)
-        {
-          Nes = 4;
-        }
-      if (txVector.GetChannelWidth () == 160
-          && txVector.GetNss (staId) == 4
-          && payloadMode.GetMcsValue () >= 2)
-        {
-          Nes = 2;
-        }
-      if (txVector.GetChannelWidth () == 160
-          && txVector.GetNss (staId) == 4
-          && payloadMode.GetMcsValue () >= 4)
-        {
-          Nes = 3;
-        }
-      if (txVector.GetChannelWidth () == 160
-          && txVector.GetNss (staId) == 4
-          && payloadMode.GetMcsValue () >= 5)
-        {
-          Nes = 4;
-        }
-      if (txVector.GetChannelWidth () == 160
-          && txVector.GetNss (staId) == 4
-          && payloadMode.GetMcsValue () >= 7)
-        {
-          Nes = 6;
-        }
-    }
-
-  Time symbolDuration = Seconds (0);
-  switch (payloadMode.GetModulationClass ())
-    {
-    case WIFI_MOD_CLASS_OFDM:
-    case WIFI_MOD_CLASS_ERP_OFDM:
-      {
-        //(Section 18.3.2.4 "Timing related parameters" Table 18-5 "Timing-related parameters"; IEEE Std 802.11-2012
-        //corresponds to T_{SYM} in the table)
-        switch (txVector.GetChannelWidth ())
-          {
-          case 20:
-          default:
-            symbolDuration = MicroSeconds (4);
-            break;
-          case 10:
-            symbolDuration = MicroSeconds (8);
-            break;
-          case 5:
-            symbolDuration = MicroSeconds (16);
-            break;
-          }
-        break;
-      }
-    case WIFI_MOD_CLASS_HT:
-    case WIFI_MOD_CLASS_VHT:
-      {
-        //if short GI data rate is used then symbol duration is 3.6us else symbol duration is 4us
-        //In the future has to create a station manager that only uses these data rates if sender and receiver support GI
-        uint16_t gi = txVector.GetGuardInterval ();
-        NS_ASSERT (gi == 400 || gi == 800);
-        symbolDuration = NanoSeconds (3200 + gi);
-      }
-      break;
-    case WIFI_MOD_CLASS_HE:
-      {
-        //if short GI data rate is used then symbol duration is 3.6us else symbol duration is 4us
-        //In the future has to create a station manager that only uses these data rates if sender and receiver support GI
-        uint16_t gi = txVector.GetGuardInterval ();
-        NS_ASSERT (gi == 800 || gi == 1600 || gi == 3200);
-        symbolDuration = NanoSeconds (12800 + gi);
-      }
-      break;
-    default:
-      break;
-    }
-
-  double numDataBitsPerSymbol = payloadMode.GetDataRate (txVector, staId) * symbolDuration.GetNanoSeconds () / 1e9;
-
-  double numSymbols = 0;
-  if (mpdutype == FIRST_MPDU_IN_AGGREGATE)
-    {
-      //First packet in an A-MPDU
-      numSymbols = (stbc * (16 + size * 8.0 + 6 * Nes) / (stbc * numDataBitsPerSymbol));
-      if (incFlag == 1)
-        {
-          totalAmpduSize += size;
-          totalAmpduNumSymbols += numSymbols;
-        }
-    }
-  else if (mpdutype == MIDDLE_MPDU_IN_AGGREGATE)
-    {
-      //consecutive packets in an A-MPDU
-      numSymbols = (stbc * size * 8.0) / (stbc * numDataBitsPerSymbol);
-      if (incFlag == 1)
-        {
-          totalAmpduSize += size;
-          totalAmpduNumSymbols += numSymbols;
-        }
-    }
-  else if (mpdutype == LAST_MPDU_IN_AGGREGATE)
-    {
-      //last packet in an A-MPDU
-      uint32_t totalSize = totalAmpduSize + size;
-      numSymbols = lrint (stbc * ceil ((16 + totalSize * 8.0 + 6 * Nes) / (stbc * numDataBitsPerSymbol)));
-      NS_ASSERT (totalAmpduNumSymbols <= numSymbols);
-      numSymbols -= totalAmpduNumSymbols;
-      if (incFlag == 1)
-        {
-          totalAmpduSize = 0;
-          totalAmpduNumSymbols = 0;
-        }
-    }
-  else if (mpdutype == NORMAL_MPDU || mpdutype == SINGLE_MPDU)
-    {
-      //Not an A-MPDU or single MPDU (i.e. the current payload contains both service and padding)
-      //The number of OFDM symbols in the data field when BCC encoding
-      //is used is given in equation 19-32 of the IEEE 802.11-2016 standard.
-      numSymbols = lrint (stbc * ceil ((16 + size * 8.0 + 6.0 * Nes) / (stbc * numDataBitsPerSymbol)));
-    }
-  else
-    {
-      NS_FATAL_ERROR ("Unknown MPDU type");
-    }
-
-  switch (payloadMode.GetModulationClass ())
-    {
-    case WIFI_MOD_CLASS_OFDM:
-    case WIFI_MOD_CLASS_ERP_OFDM:
-      {
-        //Add signal extension for ERP PHY
-        if (payloadMode.GetModulationClass () == WIFI_MOD_CLASS_ERP_OFDM)
-          {
-            return FemtoSeconds (static_cast<uint64_t> (numSymbols * symbolDuration.GetFemtoSeconds ())) + MicroSeconds (6);
-          }
-        else
-          {
-            return FemtoSeconds (static_cast<uint64_t> (numSymbols * symbolDuration.GetFemtoSeconds ()));
-          }
-      }
-    case WIFI_MOD_CLASS_HT:
-    case WIFI_MOD_CLASS_VHT:
-      {
-        if ((payloadMode.GetModulationClass () == WIFI_MOD_CLASS_HT) && (band == WIFI_PHY_BAND_2_4GHZ)
-            && (mpdutype == NORMAL_MPDU || mpdutype == SINGLE_MPDU || mpdutype == LAST_MPDU_IN_AGGREGATE)) //at 2.4 GHz
-          {
-            return FemtoSeconds (static_cast<uint64_t> (numSymbols * symbolDuration.GetFemtoSeconds ())) + MicroSeconds (6);
-          }
-        else //at 5 GHz
-          {
-            return FemtoSeconds (static_cast<uint64_t> (numSymbols * symbolDuration.GetFemtoSeconds ()));
-          }
-      }
-    case WIFI_MOD_CLASS_HE:
-      {
-        if ((band == WIFI_PHY_BAND_2_4GHZ)
-            && ((mpdutype == NORMAL_MPDU || mpdutype == SINGLE_MPDU || mpdutype == LAST_MPDU_IN_AGGREGATE))) //at 2.4 GHz
-          {
-            return FemtoSeconds (static_cast<uint64_t> (numSymbols * symbolDuration.GetFemtoSeconds ())) + MicroSeconds (6);
-          }
-        else //at 5 GHz or 6 GHz
-          {
-            return FemtoSeconds (static_cast<uint64_t> (numSymbols * symbolDuration.GetFemtoSeconds ()));
-          }
-      }
-    case WIFI_MOD_CLASS_DSSS:
-    case WIFI_MOD_CLASS_HR_DSSS:
-      return MicroSeconds (lrint (ceil ((size * 8.0) / (payloadMode.GetDataRate (22) / 1.0e6))));
-    default:
-      NS_FATAL_ERROR ("unsupported modulation class");
-      return MicroSeconds (0);
-    }
-}
-
-Time
-WifiPhy::CalculatePhyPreambleAndHeaderDuration (WifiTxVector txVector)
-{
-  WifiPreamble preamble = txVector.GetPreambleType ();
-  Time duration = GetPhyPreambleDuration (txVector)
-    + GetPhyHeaderDuration (txVector)
-    + GetPhyHtSigHeaderDuration (preamble)
-    + GetPhySigA1Duration (preamble)
-    + GetPhySigA2Duration (preamble)
-    + GetPhyTrainingSymbolDuration (txVector)
-    + GetPhySigBDuration (preamble);
-  return duration;
-}
-
-Time
-WifiPhy::CalculateTxDuration (uint32_t size, WifiTxVector txVector, WifiPhyBand band, uint16_t staId)
-{
-  Time duration = CalculatePhyPreambleAndHeaderDuration (txVector)
-    + GetPayloadDuration (size, txVector, band, NORMAL_MPDU, staId);
-  NS_ASSERT (duration.IsStrictlyPositive ());
-  return duration;
-}
-
-Time
-WifiPhy::CalculateTxDuration (WifiConstPsduMap psduMap, WifiTxVector txVector, WifiPhyBand band)
-{
-  Time maxDuration = Seconds (0);
-  for (auto & staIdPsdu : psduMap)
-    {
-      if (txVector.GetPreambleType () == WIFI_PREAMBLE_HE_MU)
-        {
-          WifiTxVector::HeMuUserInfoMap userInfoMap = txVector.GetHeMuUserInfoMap ();
-          NS_ABORT_MSG_IF (userInfoMap.find (staIdPsdu.first) == userInfoMap.end (), "STA-ID in psduMap (" << staIdPsdu.first << ") should be referenced in txVector");
-        }
-      Time current = CalculateTxDuration (staIdPsdu.second->GetSize (), txVector, band, staIdPsdu.first);
-      if (current > maxDuration)
-        {
-          maxDuration = current;
-        }
-    }
-  NS_ASSERT (maxDuration.IsStrictlyPositive ());
-  return maxDuration;
-}
-
-void
-WifiPhy::NotifyTxBegin (WifiConstPsduMap psdus, double txPowerW)
-{
-  for (auto const& psdu : psdus)
+  for (auto const& psdu : psdus)
     {
       for (auto& mpdu : *PeekPointer (psdu.second))
         {
@@ -2697,19 +1758,17 @@
     }
 }
 
-void
-WifiPhy::NotifyEndOfHePreamble (HePreambleParameters params)
+WifiConstPsduMap
+WifiPhy::GetWifiConstPsduMap (Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector)
 {
-  m_phyEndOfHePreambleTrace (params);
+  return GetStaticPhyEntity (txVector.GetModulationClass ())->GetWifiConstPsduMap (psdu, txVector);
 }
 
 void
-WifiPhy::Send (Ptr<const WifiPsdu> psdu, WifiTxVector txVector)
+WifiPhy::Send (Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector)
 {
   NS_LOG_FUNCTION (this << *psdu << txVector);
-  WifiConstPsduMap psdus;
-  psdus.insert (std::make_pair (SU_STA_ID, psdu));
-  Send (psdus, txVector);
+  Send (GetWifiConstPsduMap (psdu, txVector), txVector);
 }
 
 void
